unit Haupt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, Clipbrd;

const
  SDFaktor=6; SPFaktor=5; FFaktor=3;
  fFenster=clGreen; fFeld=clOlive; fFeldRand=clMaroon;
  fTransparent=clRed; fFeldLinien=clBlack;
  fStein=clBlack; fSteinRand=clWhite; fSteinPunkt=clWhite;
  fSteinSchatten=clBlack; fSteinLinie=clGray;
  fMarkMark=clYellow; fMarkNorm=clBlack;

type
  TStein=class;
  TSteinArray=array[0..9,0..9]of TStein;
  TBesetzt=array[0..10,0..11]of TStein;

  TStein=class(TImage)
  private
    Ecken:array[0..8]of TPoint;
    AKoo:TPoint;
    AAug:TPoint;
    ONr:integer;
    constructor Create(AOwner:TComponent); override;
    procedure SetKoo(l,t,a1,a2:integer; r:boolean);
    procedure SetFenster(a1,a2:integer);
    procedure ZeichneAuge(c:TCanvas;x1,y1,x2,y2,a:integer);
    procedure ZeichnePunkt(c:TCanvas;x,y:integer);
    procedure SMouseMove(Sender:TObject;Shift:TShiftState;X,Y:Integer);
    procedure SClick(Sender: TObject);
    procedure SMouseDown(Sender:TObject;Button:TMouseButton;
                         Shift:TShiftState;X,Y:Integer);
  public
    FKoo:TPoint;
    FWaag:boolean;
    LKoo:TPoint;
    LWaag:boolean;
    procedure SetFeld(x,y:integer;w:boolean;p:TWinControl;var f:TBesetzt);
  end;

  TAuswahl=class(TBevel)
    constructor Create(AOwner:TComponent); override;
    procedure AMouseDown(Sender:TObject;Button:TMouseButton;
                                          Shift:TShiftState;X,Y:Integer);
    procedure AClick(Sender:TObject);
    procedure ADblClick(Sender:TObject);
  private
    Koo:TPoint;
    Waag:boolean;
    function SetKoo(x,y:integer;w:boolean):boolean;
  end;

  TMarke=class(TLabel)
    constructor Create(AOwner:TComponent); override;
  private
    FMark:boolean;
    procedure SetMark(m:boolean);
  public
    property Mark:boolean Read FMark Write SetMark;
  end;

  THauptfenster = class(TForm)
    FeldRand: TPanel;
    Feld: TPaintBox;
    Menu: TMainMenu;
    MenuSpiel: TMenuItem;
    MenuSpielNeu: TMenuItem;
    MenuSpielMit: TMenuItem;
     MenuMit1: TMenuItem;
     MenuMit2: TMenuItem;
     MenuMit3: TMenuItem;
     MenuMit4: TMenuItem;
     MenuMit5: TMenuItem;
     MenuMit6: TMenuItem;
     MenuMit7: TMenuItem;
     MenuMit8: TMenuItem;
     MenuMit9: TMenuItem;
    MenuSpielWieder: TMenuItem;
    T1: TMenuItem;
    MenuSpielLaden: TMenuItem;
    MenuSpielSpeichern: TMenuItem;
    T2: TMenuItem;
    MenuZwischenAblegen: TMenuItem;
    MenuZwischenHolen: TMenuItem;
    T3: TMenuItem;
    MenuSpielFeld: TMenuItem;
     MenuFeld0: TMenuItem;
     MenuFeld1: TMenuItem;
     MenuFeld2: TMenuItem;
     MenuFeld3: TMenuItem;
     MenuFeld4: TMenuItem;
     MenuFeld5: TMenuItem;
     MenuFeld6: TMenuItem;
     MenuFeld7: TMenuItem;
     MenuFeld8: TMenuItem;
     MenuFeld9: TMenuItem;
    MenuSpielLoesung: TMenuItem;
    T4: TMenuItem;
    MenuSpielEnde: TMenuItem;
    SpielSpeichernDialog: TSaveDialog;
    SpielLadenDialog: TOpenDialog;
    GeloestPanel: TPanel;
    GeloestLabel: TStaticText;
    AnzSteineLabel: TLabel;
    AnzAugenLabel: TLabel;
    AnzZwischenLabel: TLabel;
    AnzRueckLabel: TLabel;
    AusDateiLabel: TLabel;
    MenuHilfe: TMenuItem;
    MenuHilfeRegel: TMenuItem;
    MenuHilfeBedienung: TMenuItem;
    MenuHilfeEinstellen: TMenuItem;
    MenuHilfeTricks: TMenuItem;
    H1: TMenuItem;
    MenuHilfeMenu: TMenuItem;
    FertigPanel: TPanel;
    FertigLabel1: TLabel;
    FertigLabel: TStaticText;
    FertigLabel2: TLabel;
    H2: TMenuItem;
    MenuHilfeInfo: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FeldPaint(Sender:TObject);
    procedure FeldMouseMove(Sender:TObject;Shift:TShiftState;X,Y:Integer);
    procedure FormMouseMove(Sender:TObject;Shift:TShiftState;X,Y:Integer);
    procedure FeldRandMouseMove(Sender:TObject;Shift:TShiftState;X,Y:Integer);
    procedure FeldRandClick(Sender: TObject);
    procedure MenuSpielNeuClick(Sender: TObject);
    procedure MenuMitClick(Sender: TObject);
    procedure MenuSpielWiederClick(Sender: TObject);
    procedure MenuSpielLadenClick(Sender: TObject);
    procedure MenuSpielSpeichernClick(Sender: TObject);
    procedure MenuZwischenAblegenClick(Sender: TObject);
    procedure MenuZwischenHolenClick(Sender: TObject);
    procedure MenuFeldClick(Sender: TObject);
    procedure MenuSpielLoesungClick(Sender: TObject);
    procedure MenuSpielEndeClick(Sender: TObject);
    procedure MenuHilfeRegelClick(Sender: TObject);
    procedure MenuHilfeBedienungClick(Sender: TObject);
    procedure MenuHilfeTricksClick(Sender: TObject);
    procedure MenuHilfeEinstellenClick(Sender: TObject);
    procedure MenuHilfeMenuClick(Sender: TObject);
    procedure MenuHilfeInfoClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Zwischenstand:string;
    procedure SteineIni;
    procedure PunkteIni(n:boolean);
    procedure SetzeNeu;
    procedure AOrdne(x,y:integer);
    procedure MarkenIni;
    procedure SetMarken;
    function SpielToString(f:boolean):string;
    procedure StringToSpiel(z:string;f:boolean);
  public
    { Public-Deklarationen }
  end;

var
  Hauptfenster: THauptfenster;
  SBreite:integer;
  Max:integer;
  Steine:TSteinArray;
  FPunkte:array[0..10,0..11]of integer;
  FBreite,FHoehe:integer; {in Ksten}
  Block:boolean;
procedure FOrdne(a:TSteinArray;b,h:integer;f:TBesetzt);

implementation
uses Loesung, Hilfe;
{$R *.DFM}

var
  Auswahl:TAuswahl;
  Ax,Ay:integer; {in Pixeln}
  ABreite,AHoehe:integer; {in Steinen}
  FBesetzt:TBesetzt;
  Marken:array[0..10,0..11]of TMarke;
  ASteine:array[0..10,0..6]of TStein;
  AnzAugen,AnzSteine,AnzRueck,AnzZwischen:integer; {Hilfen benutzt}
  AusDatei:boolean;
  Ende:boolean;

procedure THauptfenster.FormCreate(Sender: TObject);
var a1,a2,x,y:integer; s:TStein;
begin
   Ende:=false; Color:=fFenster; FeldRand.Color:=fFeldRand;
   for a1:=0 to 9 do for a2:=0 to 9 do
   begin
      if a2>=a1 then s:=TStein.Create(Self) else s:=Steine[a2,a1];
      Steine[a1,a2]:=s;
   end;
   Auswahl:=TAuswahl.Create(Self);
   SpielLadenDialog.InitialDir:=ExtractFileDir(ParamStr(0));
   SpielSpeichernDialog.InitialDir:=ExtractFileDir(ParamStr(0));
   for x:=0 to 10 do for y:=0 to 11 do Marken[x,y]:=TMarke.Create(Self);
   Randomize; Max:=6; SteineIni; PunkteIni(true); SetzeNeu;
end;

procedure THauptfenster.SteineIni;
   {ntig nach ndern von Max; dann noch SetzeNeu oder Resize}
var a1,a2,x,y,i:integer; s:TStein;
begin
   FBreite:=Max+1; FHoehe:=Max+2;
   ABreite:=Max+2; AHoehe:=(Max+1)div 2+1;
   for x:=0 to 10 do for y:=0 to 6 do ASteine[x,y]:=nil;
   for x:=0 to 10 do for y:=0 to 11 do
   begin
      FBesetzt[x,y]:=nil;
      Marken[x,y].Visible:=(x<FBreite)and(y<FHoehe);
   end;
   MarkenIni;
   for a1:=0 to 9 do for a2:=a1 to 9 do
   begin
      s:=Steine[a1,a2]; s.FKoo:=Point(-1,-1);
      s.Visible:=(a1<=Max)and(a2<=Max);
      if a1<AHoehe then begin x:=a2-a1; y:=a1 end
                   else begin x:=a2+1; y:=2*AHoehe-a1-1 end;
      ASteine[x,y]:=s; s.AKoo:=Point(x,y); s.AAug:=Point(a1,a2);
   end;
   for i:=0 to 9 do
   begin
      MenuSpielFeld.Items[i].Visible:=(i<=Max);
      MenuSpielFeld.Items[i].Checked:=false;
   end;
   Zwischenstand:='';
   AnzAugen:=0; AnzSteine:=0; AnzRueck:=0; AnzZwischen:=0; AusDatei:=false;
end;

procedure THauptfenster.PunkteIni;
var a,x,y,xm,ym,r,s,f,a1,a2,i:integer; v:array[1..55]of TPoint;
begin
   for x:=0 to FBreite-1 do for y:=0 to FHoehe-1 do FPunkte[x,y]:=-1;
   a:=0; y:=0;
   for a1:=0 to Max do for a2:=a1 to Max do
      begin a:=a+1; v[a]:=Point(a1,a2) end;
   while a>0 do
   begin
      r:=-1; s:=2*Max+4; f:=0; xm:=-1; ym:=-1;
      for x:=0 to FBreite-1 do
      begin
         for y:=0 to FHoehe-1 do
         begin
            f:=0;
            if FPunkte[x,y]<0 then
            begin
               if x+y<s then begin s:=x+y; xm:=x; ym:=y end;
               if y+1<FHoehe then
                  if FPunkte[x,y+1]<0 then begin f:=f+1; r:=1 end;
               if x+1<FBreite then
                  if FPunkte[x+1,y]<0 then begin f:=f+1; r:=0 end;
               if y>0 then if FPunkte[x,y-1]<0 then f:=f+1;
               if x>0 then if FPunkte[x-1,y]<0 then f:=f+1;
            end;
            if f=1 then break;
         end;
         if f=1 then break;
      end;
      if f>1 then begin r:=Random(2); x:=xm; y:=ym end;
      i:=Random(a)+1;
      if Random(2)>0 then
      begin
         FPunkte[x,y]:=v[i].X; FPunkte[x+1-r,y+r]:=v[i].Y;
      end else
      begin
         FPunkte[x,y]:=v[i].Y; FPunkte[x+1-r,y+r]:=v[i].X;
      end;
      Steine[v[i].X,v[i].Y].LKoo:=Point(x,y);
      Steine[v[i].X,v[i].Y].LWaag:=(r=0);
      v[i]:=v[a]; a:=a-1;
   end;
   SetMarken; Feld.Repaint;
end;

procedure THauptfenster.SetMarken;
var x,y:integer;
begin
   for x:=0 to FBreite-1 do for y:=0 to FHoehe-1 do
      Marken[x,y].Caption:=chr(ord('0')+FPunkte[x,y]);
end;

procedure THauptfenster.FormResize(Sender: TObject);
var b,h,x,y,d:integer;
begin
   if Ende then exit;
   b:=ClientWidth div (FBreite+ABreite+5);
   h:=ClientHeight div (FHoehe+2);
   if b<h then SBreite:=b else SBreite:=h;
   b:=FBreite*SBreite+1; h:=FHoehe*SBreite+1;
   FeldRand.SetBounds(SBreite,(ClientHeight-h-2*SBreite)div 2,
                      b+2*SBreite,h+2*SBreite);
   Feld.SetBounds(SBreite,SBreite,b,h);
   for x:=0 to FBreite-1 do for y:=0 to FHoehe-1 do
   begin
      d:=SBreite div FFaktor+1;
      Marken[x,y].SetBounds((x+1)*SBreite+(SBreite-d)div 2+1,
                            (y+1)*SBreite+(SBreite-d)div 2,d,d);
      Marken[x,y].Font.Height:=d-1;
   end;
   Auswahl.BringToFront;
   d:=SBreite div SDFaktor;
   Ax:=ClientWidth-(ABreite+1)*SBreite-d;
   Ay:=(ClientHeight-2*AHoehe*SBreite)div 2 -d;
   GeloestPanel.SetBounds(Ax,(ClientHeight-GeloestPanel.Height)div 2,
                          GeloestPanel.Width,GeloestPanel.Height);
   FertigPanel.SetBounds(Ax,(ClientHeight-FertigPanel.Height)div 2,
                          FertigPanel.Width,FertigPanel.Height);
   SetzeNeu;
end;

procedure THauptfenster.SetzeNeu;
var a1,a2:integer; s:TStein;
begin
   for a1:=0 to Max do for a2:=a1 to Max do
   begin
      s:=Steine[a1,a2];
      if s.Visible then
      begin
         if s.FKoo.x<0 then s.SetFenster(a1,a2)
            else s.SetFeld(s.FKoo.x,s.FKoo.y,s.FWaag,FeldRand,FBesetzt);
      end;
   end;
   GeloestPanel.Hide; FertigPanel.Hide; Block:=false; MarkenIni;
   AOrdne(ABreite-1,0); FOrdne(Steine,FBreite-1,0,FBesetzt);
end;

procedure THauptfenster.AOrdne(x,y:integer);
var i,j:integer; s:TStein;
begin
   for i:=x downto 0 do for j:=y to AHoehe-1 do
   begin
      s:=ASteine[i,j];
      if s<>nil then if s.FKoo.x<0 then ASteine[i,j].BringToFront;
   end;
end;

procedure FOrdne(a:TSteinArray;b,h:integer;f:TBesetzt);
var a1,a2,m,i:integer;
   procedure nachbarn(x,y,n:integer);
   var s:TStein;
   begin
      if (x<0)or(y>FHoehe-1) then exit;
      s:=f[x,y];
      if s<>nil then
      begin
         if s.ONr>=n then exit;
         s.ONr:=n; x:=s.FKoo.x; y:=s.FKoo.y;
         if n>m then m:=n;
         nachbarn(x-1,y,n+1);
         if s.FWaag then begin nachbarn(x+1,y+1,n+1); nachbarn(x,y+1,n+1) end
                    else begin nachbarn(x-1,y+1,n+1); nachbarn(x,y+2,n+1) end;
      end else begin nachbarn(x-1,y,1); nachbarn(x,y+1,1) end;
   end;
begin
   for a1:=0 to Max do for a2:=a1 to Max do a[a1,a2].ONr:=0;
   m:=0; nachbarn(b,h,1);
   for i:=1 to m do
      for a1:=0 to Max do for a2:=a1 to Max do
         if a[a1,a2].ONr=i then a[a1,a2].BringToFront;
end;

procedure THauptfenster.FormClick(Sender: TObject);
begin MarkenIni end;

procedure THauptfenster.FormClose(Sender:TObject; var Action:TCloseAction);
var a1,a2,x,y:integer;
begin
   Ende:=true; Auswahl.Hide;
   for a1:=0 to 9 do for a2:=a1 to 9 do Steine[a1,a2].free;
   for x:=0 to 10 do for y:=0 to 11 do Marken[x,y].Free;
end;

procedure THauptfenster.FeldPaint(Sender:TObject);
var i:integer;
begin
   Feld.Canvas.Brush.Color:=fFeld; Feld.Canvas.Pen.Color:=fFeldLinien;
   Feld.Canvas.FillRect(Rect(1,1,Feld.Width,Feld.Height));
   for i:=1 to FHoehe-1 do
   begin
      Feld.Canvas.MoveTo(0,i*SBreite);
      Feld.Canvas.LineTo(FBreite*SBreite,i*SBreite);
   end;
   for i:=1 to FBreite-1 do
   begin
      Feld.Canvas.MoveTo(i*SBreite,0);
      Feld.Canvas.LineTo(i*SBreite,FHoehe*SBreite);
   end;
end;

procedure THauptfenster.FeldMouseMove(Sender:TObject;Shift:TShiftState;
                                                               X,Y:Integer);
var mx,my,nx,ny,dx,dy,ex,ey:integer; b:boolean;
begin
   if Block then exit;
   mx:=X div SBreite; my:=Y div SBreite;
   if FBesetzt[mx,my]<>nil then exit;
   if Auswahl.Koo.x<0 then
      begin nx:=mx; ny:=my; Auswahl.Koo:=Point(mx,my) end
   else begin nx:=Auswahl.Koo.x; ny:=Auswahl.Koo.y end;
   if Auswahl.Waag then begin dx:=1; dy:=0 end
                   else begin dx:=0; dy:=1 end;
   if Auswahl.Visible then
      if ((mx=nx)or(mx=nx+dx))and((my=ny)or(my=ny+dy))then exit;
   if mx>nx then ex:=1 else ex:=0;
   if my>ny then ey:=1 else ey:=0;
   b:=Auswahl.SetKoo(mx-ex*dx,my-ey*dy,Auswahl.Waag);
   if not b then b:=Auswahl.SetKoo(mx-(1-ex)*dx,my-(1-ey)*dy,Auswahl.Waag);
   if not b then b:=Auswahl.SetKoo(mx-ex*dy,my-ey*dx,not Auswahl.Waag);
   if not b then b:=Auswahl.SetKoo(mx-(1-ex)*dy,my-(1-ey)*dx,not Auswahl.Waag);
   if b and(not Auswahl.Visible) then Auswahl.Show;
   Application.ProcessMessages;
end;

procedure THauptfenster.FormMouseMove(Sender:TObject;Shift:TShiftState;
                                                               X,Y:Integer);
begin
   Auswahl.Hide; Auswahl.Koo:=Point(-1,-1);
   Auswahl.Waag:=(X<=FeldRand.Left)or(Y>=FeldRand.Left+FeldRand.Width);
end;

procedure THauptfenster.FeldRandMouseMove(Sender:TObject;Shift:TShiftState;
                                                               X,Y:Integer);
begin
   Auswahl.Hide; Auswahl.Koo:=Point(-1,-1);
   Auswahl.Waag:=(X<=Feld.Left)or(Y>=Feld.Left+Feld.Width);
end;

procedure THauptfenster.FeldRandClick(Sender: TObject);
begin MarkenIni end;

procedure THauptfenster.MarkenIni;
var x,y:integer;
begin
   for x:=0 to 10 do for y:=0 to 11 do Marken[x,y].Mark:=false;
end;

function THauptfenster.SpielToString(f:boolean):string;
   {Koordinaten waag,senk: A,a=0;  B,b=1; ...
    1.Buchstabe (waag): gro(A...):senkrecht, klein(a...):waagrecht;
    2.Buchstabe (senk): gro(A...):a1>a2; klein(a...):a1<=a2
    Reihenfolge 0-0,0-1,0-2,...,1-1,1-2,...}
var a1,a2,a,b:integer; z:string; t:TStein; k:TPoint; w:boolean;
begin
   z:='';
   for a1:=0 to Max do for a2:=a1 to Max do
   begin
      t:=Steine[a1,a2];
      if f then begin k:=t.FKoo; w:=t.FWaag end
           else begin k:=t.LKoo; w:=t.LWaag end;
      if k.x>=0 then
      begin
         if w then a:=ord('a') else a:=ord('A');
         if a1=FPunkte[k.x,k.y] then b:=ord('a') else b:=ord('A');
         z:=z+chr(k.x+a)+chr(k.y+b);
      end else z:=z+'00';
   end;
   Result:=z;
end;

procedure THauptfenster.StringToSpiel(z:String; f:boolean);
  {f=true:akt.Stellung; f=false:Lsung}
var i,a1,a2,u1,u2,x,y:integer; s:TStein; w,v:boolean;
begin
   if f then for a1:=0 to Max do for a2:=a1 to Max do
      begin s:=Steine[a1,a2]; if s.FKoo.x>=0 then s.SetFenster(a1,a2) end;
   z:=trim(z); i:=1;
   for a1:=0 to Max do for a2:=a1 to Max do
   begin
      w:=(z[i]>='a'); if w then x:=ord('a') else x:=ord('A');
      v:=(z[i+1]>='a'); if v then y:=ord('a') else y:=ord('A');
      if z[i]='0' then begin x:=-1; y:=-1 end
                  else begin x:=ord(z[i])-x; y:=ord(z[i+1])-y end;
      s:=Steine[a1,a2];
      if f then
      begin
         s.FKoo:=Point(x,y); s.FWaag:=w;
      end else
      begin
         s.LKoo:=Point(x,y); s.LWaag:=w;
         if not v then begin u1:=a2; u2:=a1 end else begin u1:=a1; u2:=a2 end;
         FPunkte[x,y]:=u1;
         if w then FPunkte[x+1,y]:=u2 else FPunkte[x,y+1]:=u2;
      end;
      i:=i+2;
   end;
end;

constructor TStein.Create(AOwner:TComponent);
begin
   inherited Create(AOwner);
   Visible:=false; Transparent:=true;
   OnMouseMove:=SMouseMove; OnClick:=SClick; OnMouseDown:=SMouseDown;
end;

procedure TStein.SetKoo(l,t,a1,a2:integer; r:boolean);
{                xl xm               xu xr
                    1--------7----------0 yo
                   /|                   |
               yl 4 |                   |
                  | 2--------8----------3 ym
                  |/                   /
               yu 5-------------------6
}
var d,w,h,xl,xm,xu,xr,yo,yl,ym,yu:integer;
var q:array[0..6]of TPoint; p:array[0..4]of TPoint; b:TBitmap;
begin
   FWaag:=r; d:=SBreite div SDFaktor;
   w:=SBreite+d+1; h:=w;
   xl:=2; xm:=d; xu:=SBreite-2; xr:=w-4;
   yo:=2; yl:=d+1; ym:=SBreite-1; yu:=h-3;
   if FWaag then
   begin
      w:=w+SBreite; xu:=xu+SBreite; xr:=xr+SBreite;
      Ecken[7]:=Point((xr+xm)div 2,yo+3);
      Ecken[8]:=Point((xr+xm)div 2,ym-2);
   end else
   begin
      h:=h+SBreite; ym:=ym+SBreite; yu:=yu+SBreite;
      Ecken[7]:=Point(xm+4,(yo+ym)div 2);
      Ecken[8]:=Point(xr-3,(yo+ym)div 2);
   end;
   Ecken[0]:=Point(xr,yo); Ecken[1]:=Point(xm,yo);
   Ecken[2]:=Point(xm,ym); Ecken[3]:=Point(xr,ym);
   Ecken[4]:=Point(xl,yl); Ecken[5]:=Point(xl,yu);
   Ecken[6]:=Point(xu,yu);
   SetBounds(l,t,w,h);

   Picture.Bitmap.Width:=Width; Picture.Bitmap.Height:=Height;
   b:=TBitmap.Create; b.Width:=Width; b.Height:=Height;
   b.Canvas.Pen.Color:=FTransparent; b.Canvas.Brush.Color:=fTransparent;
   b.Canvas.Rectangle(0,0,width,height);
   q[0]:=Ecken[0]; q[1]:=Ecken[1]; q[2]:=Ecken[4];
   q[3]:=Ecken[5]; q[4]:=Ecken[6]; q[5]:=Ecken[3]; q[6]:=q[0];
   b.Canvas.Brush.Color:=fStein; b.Canvas.Pen.Color:=fSteinRand;
   b.Canvas.Pen.Width:=1; b.Canvas.Polygon(q);
   b.Canvas.MoveTo(Ecken[1].X,Ecken[1].Y);
   b.Canvas.LineTo(Ecken[2].X,Ecken[2].Y);
   b.Canvas.LineTo(Ecken[3].X,Ecken[3].Y);
   b.Canvas.MoveTo(Ecken[2].X+1,Ecken[2].Y);
   b.Canvas.LineTo(Ecken[5].X,Ecken[5].Y);
   p[0]:=Ecken[0]; p[0]:=Point(p[0].X-1,p[0].Y+1);
   p[1]:=Ecken[1]; p[1]:=Point(p[1].X+1,p[1].Y+1);
   p[2]:=Ecken[2]; p[2]:=Point(p[2].X+1,p[2].Y-1);
   p[3]:=Ecken[3]; p[3]:=Point(p[3].X-1,p[3].Y-1); p[4]:=p[0];
   b.Canvas.Polyline(p);
   b.Canvas.Pen.Color:=FSteinLinie;
   b.Canvas.MoveTo(Ecken[7].X,Ecken[7].Y);
   b.Canvas.LineTo(Ecken[8].X,Ecken[8].Y);
   if FWaag then
   begin
      ZeichneAuge(b.Canvas,Ecken[1].X+2,Ecken[1].Y+3,Ecken[8].X-1,Ecken[8].Y+2,a1);
      ZeichneAuge(b.Canvas,Ecken[7].X+2,Ecken[7].Y+1,Ecken[3].X,Ecken[3].Y+1,a2);
   end else
   begin
      ZeichneAuge(b.Canvas,Ecken[1].X+4,Ecken[1].Y+1,Ecken[8].X+1,Ecken[8].Y,a1);
      ZeichneAuge(b.Canvas,Ecken[7].X-1,Ecken[7].Y+1,Ecken[3].X,Ecken[3].Y+1,a2);
   end;
   BitBlt(Canvas.Handle,0,0,Width,Height,b.Canvas.Handle,0,0,SrcCopy);
   b.Free;
end;

procedure TStein.SetFeld(x,y:integer;w:boolean;p:TWinControl;var f:TBesetzt);
var a1,a2:integer;
begin
   Parent:=p;
   if FKoo.x>=0 then
   begin
      f[FKoo.x,FKoo.y]:=nil;
      if FWaag then f[FKoo.x+1,FKoo.y]:=nil  else f[FKoo.x,FKoo.y+1]:=nil;
   end;
   FKoo:=Point(x,y); FWaag:=w;
   a1:=FPunkte[x,y];
   if w then a2:=FPunkte[x+1,y] else a2:=FPunkte[x,y+1];
   SetKoo(x*SBreite+Hauptfenster.Feld.Left,
          y*SBreite-SBreite div SDFaktor-1+Hauptfenster.Feld.Top,a1,a2,w);
   f[x,y]:=Self;
   if FWaag then f[x+1,y]:=Self else f[x,y+1]:=Self;
end;

procedure TStein.SetFenster(a1,a2:integer);
var a:integer;
begin
   Parent:=Hauptfenster;
   if a1>a2 then begin a:=a1; a1:=a2; a2:=a end;
   if FKoo.x>=0 then
   begin
      FBesetzt[FKoo.x,FKoo.y]:=nil;
      if FWaag then FBesetzt[FKoo.x+1,FKoo.y]:=nil
               else FBesetzt[FKoo.x,FKoo.y+1]:=nil;
   end;
   SetKoo(AKoo.x*SBreite+Ax,2*AKoo.y*SBreite+Ay,a1,a2,false);
   FKoo:=Point(-1,-1);
end;

procedure TStein.ZeichneAuge(c:TCanvas;x1,y1,x2,y2,a:integer);
var xl,xm,xr,yo,ym,yu:integer;
begin
   xm:=(x2+x1)div 2; ym:=(y2+y1)div 2;
   xl:=(xm+x1)div 2; xr:=(x2+xm)div 2;
   yo:=(ym+y1)div 2; yu:=(y2+ym)div 2;
   if a in [1,3,5,7,9] then ZeichnePunkt(c,xm,ym);
   if a in [2,4,5,6,7,8,9] then
      begin ZeichnePunkt(c,xl,yo); ZeichnePunkt(c,xr,yu) end;
   if a in [3,4,5,6,7,8,9] then
      begin ZeichnePunkt(c,xr,yo); ZeichnePunkt(c,xl,yu) end;
   if a in [6,7,8,9] then
      begin ZeichnePunkt(c,xm,yo); ZeichnePunkt(c,xm,yu) end;
   if a in [8,9] then
      begin ZeichnePunkt(c,xl,ym); ZeichnePunkt(c,xr,ym) end;
end;

procedure TStein.ZeichnePunkt(c:TCanvas;x,y:integer);
var d:integer;
begin
   d:=SBreite div(2*SPFaktor); c.Pen.Width:=1;
   c.Pen.Color:=fSteinSchatten; c.Brush.Color:=fSteinPunkt;
   c.Ellipse(x-d+1,y-d,x+d+1,y+d);
   c.Ellipse(x-d,y-d,x+d,y+d);
end;

procedure TStein.SMouseMove(Sender:TObject;Shift:TShiftState;X,Y:Integer);
begin Auswahl.Hide end;

procedure TStein.SClick(Sender:TObject);
var x,y:integer; a:boolean;
begin
   if Block then exit;
   Hauptfenster.MarkenIni; a:=false;
   for x:=0 to FBreite-1 do for y:=0 to FHoehe-1 do
   begin
      if FBesetzt[x,y]=nil then
      begin
         if x<FBreite-1 then if FBesetzt[x+1,y]=nil then
            if ((FPunkte[x,y]=AAug.x)and(FPunkte[x+1,y]=AAug.y))
             or((FPunkte[x,y]=AAug.y)and(FPunkte[x+1,y]=AAug.x)) then
              begin
                 Marken[x,y].Mark:=true;
                 Marken[x+1,y].Mark:=true;
                 a:=true;
              end;
         if y<FHoehe-1 then if FBesetzt[x,y+1]=nil then
            if ((FPunkte[x,y]=AAug.x)and(FPunkte[x,y+1]=AAug.y))
             or((FPunkte[x,y]=AAug.y)and(FPunkte[x,y+1]=AAug.x)) then
              begin
                 Marken[x,y].Mark:=true;
                 Marken[x,y+1].Mark:=true;
                 a:=true;
              end;
      end;
   end;
   if a then AnzSteine:=AnzSteine+1;
end;

procedure TStein.SMouseDown(Sender:TObject;Button:TMouseButton;
                         Shift:TShiftState;X,Y:Integer);
var a1,a2:integer;
begin
   if Block then exit;
   if Button<>(mbRight) then exit;
   if FKoo.x<0 then exit;
   a1:=FPunkte[FKoo.x,FKoo.y];
   if FWaag then a2:=FPunkte[FKoo.x+1,FKoo.y]
            else a2:=FPunkte[FKoo.x,FKoo.y+1];
   SetFenster(a1,a2); AnzRueck:=AnzRueck+1;
   Hauptfenster.AOrdne(AKoo.x,AKoo.y);
   Auswahl.SetKoo(FKoo.x,FKoo.y,FWaag); Auswahl.Show;
   FKoo:=Point(-1,-1);
end;

constructor TAuswahl.Create(AOwner:TComponent);
begin
   inherited Create(AOwner);
   Parent:=Hauptfenster.FeldRand;
   Shape:=bsFrame; Visible:=false; Waag:=true;
   OnMouseDown:=AMouseDown; OnClick:=AClick; OnDblClick:=ADblClick;
end;

procedure TAuswahl.AMouseDown(Sender:TObject; Button:TMouseButton;
                              Shift:TShiftState; X,Y:Integer);
var b,w:boolean; r,q,nx,ny:integer;
begin
   if Block then exit;
   if Button<>mbRight then exit;
   if Waag then r:=(X div SBreite)*2
           else r:=3-(Y div SBreite)*2;
      {0 rechts, 2 links, 1 hoch, 3 runter}
   q:=(r+1)mod 4; nx:=Koo.x; ny:=Koo.y; w:=Waag; b:=false;
   while (q<>r)and(not b) do
   begin
      case q of
         0: ;
         1: ny:=ny-1;
         2: begin nx:=nx-1; ny:=ny+1 end;
         3: nx:=nx+1;
      end;
      w:=not w; b:=SetKoo(nx,ny,w); q:=(q+1)mod 4;
   end;
end;

procedure TAuswahl.AClick(Sender:TObject);
var b:boolean; nx,ny:integer; s:TStein;
begin
   if Block then exit;
   nx:=Koo.x; ny:=Koo.y; if Waag then nx:=nx+1 else ny:=ny+1;
   s:=Steine[FPunkte[Koo.x,Koo.y],FPunkte[nx,ny]];
   if s.FKoo.x>=0 then exit;
   Auswahl.Hide;
   s.SetFeld(Koo.x,Koo.y,Waag,Hauptfenster.FeldRand,FBesetzt);
   FOrdne(Steine,Koo.x,Koo.y,FBesetzt);
   b:=false;
   for nx:=0 to FBreite-1 do for ny:=0 to FHoehe-1 do
      if FBesetzt[nx,ny]=nil then begin b:=true; break end;
   if not b then
   begin
      Block:=true;
      Hauptfenster.AusDateiLabel.Visible:=AusDatei;
      Hauptfenster.AnzSteineLabel.Caption:=
         IntToStr(AnzSteine)+' mal Steine angezeigt';
      Hauptfenster.AnzAugenLabel.Caption:=
         IntToStr(AnzAugen)+' mal Augen angezeigt';
      Hauptfenster.AnzZwischenLabel.Caption:=
         IntToStr(AnzZwischen)+' mal Zwischenstand geholt';
      Hauptfenster.AnzRueckLabel.Caption:=
         IntToStr(AnzRueck)+' mal Steine korrigiert';
      Hauptfenster.GeloestPanel.Show;
   end;
end;

procedure TAuswahl.ADblClick(Sender:TObject);
var nx,ny:integer; s:TStein;
begin
   if Block then exit;
   nx:=Koo.x; ny:=Koo.y; if Waag then nx:=nx+1 else ny:=ny+1;
   s:=Steine[FPunkte[Koo.x,Koo.y],FPunkte[nx,ny]];
   if s.FKoo.x<0 then exit;
   Auswahl.Hide;
   s.SetFeld(Koo.x,Koo.y,Waag,Hauptfenster.FeldRand,FBesetzt);
   FOrdne(Steine,Koo.x,Koo.y,FBesetzt);
   AnzRueck:=AnzRueck+1;
end;

function TAuswahl.SetKoo(x,y:integer; w:boolean):boolean;
var b:boolean; d:integer;
begin
   d:=Hauptfenster.Feld.Left+1; b:=false;
   if w then
   begin
      if (x<FBreite-1)and(x>=0) then
         if (FBesetzt[x,y]=nil)and(FBesetzt[x+1,y]=nil) then
            begin
               b:=true;
               SetBounds(x*SBreite+d,y*SBreite+d,2*SBreite-1,SBreite-1);
            end;
   end else
   begin
      if (y<FHoehe-1)and(y>=0) then
         if (FBesetzt[x,y]=nil)and(FBesetzt[x,y+1]=nil) then
            begin
               b:=true;
               SetBounds(x*SBreite+d,y*SBreite+d,SBreite-1,2*SBreite-1);
            end;
   end;
   if b then begin Koo:=Point(x,y); Waag:=w end; Result:=b;
end;

constructor TMarke.Create(AOwner:TComponent);
begin
   inherited Create(AOwner); Transparent:=true;
   Parent:=Hauptfenster.FeldRand; Visible:=false;
   Alignment:=taCenter; Font.Style:=[fsBold];
end;

procedure TMarke.SetMark(m:boolean);
begin
   FMark:=m;
   if m then Font.Color:=fMarkMark else Font.Color:=fMarkNorm;
end;

procedure THauptfenster.MenuSpielNeuClick(Sender: TObject);
begin SteineIni; PunkteIni(true); SetzeNeu end;

procedure THauptfenster.MenuMitClick(Sender: TObject);
var i:integer;
begin
   Max:=StrToInt(Copy(TMenuItem(Sender).Caption,2,1));
   for i:=0 to 8 do MenuSpielMit.Items[i].Checked:=false;
   TMenuItem(Sender).Checked:=true;
   SteineIni; PunkteIni(true); FormResize(Self);
end;

procedure THauptfenster.MenuSpielWiederClick(Sender: TObject);
begin SteineIni; SetzeNeu end;

procedure THauptfenster.MenuSpielLadenClick(Sender: TObject);
var s:TStringList; i,m:integer;
begin
   if SpielLadenDialog.Execute then
   begin
      s:=TStringList.Create;
      s.LoadFromFile(SpielLadenDialog.FileName);
      if (s.Count=0)or(s.Count>2) then exit;
      m:=0;
      for i:=1 to 9 do
         if (i+1)*(i+2)=length(s[0]) then begin m:=i; break end;
      if m=0 then exit; Max:=m;
      SteineIni;
      StringToSpiel(s[0],false); SetMarken;
      if s.Count=2 then begin StringToSpiel(s[1],true); AusDatei:=true end;
      s.Free;
      for i:=0 to 8 do MenuSpielMit.Items[i].Checked:=(i=Max-1);
      FormResize(Self);
   end;
end;

procedure THauptfenster.MenuSpielSpeichernClick(Sender: TObject);
var s:TStringList; b:boolean; x,y:integer;
begin
   if SpielSpeichernDialog.Execute then
   begin
      s:=TStringList.Create;
      s.Add(SpielToString(false));
      b:=false;
      for x:=0 to FBreite-1 do for y:=0 to FHoehe-1 do
         if FBesetzt[x,y]<>nil then begin b:=true; break end;
      if b then s.Add(SpielToString(true));
      s.SaveToFile(SpielSpeichernDialog.FileName);
      s.Free;
   end;
end;

procedure THauptfenster.MenuZwischenAblegenClick(Sender: TObject);
begin Zwischenstand:=SpielToString(true) end;

procedure THauptfenster.MenuZwischenHolenClick(Sender: TObject);
begin
   if Zwischenstand<>'' then
   begin
      StringToSpiel(Zwischenstand,true); SetzeNeu;
      AnzZwischen:=AnzZwischen+1;
   end;
end;

procedure THauptfenster.MenuFeldClick(Sender: TObject);
var i,f,x,y:integer;
begin
   f:=StrToInt(copy(TMenuItem(Sender).Caption,2,1));
   for i:=0 to 9 do MenuSpielFeld.Items[i].Checked:=(i=f);
   for x:=0 to 10 do for y:=0 to 11 do Marken[x,y].Mark:=(FPunkte[x,y]=f);
   AnzAugen:=AnzAugen+1;
end;

procedure THauptfenster.MenuSpielLoesungClick(Sender: TObject);
begin
   Block:=true; LoesungsFenster.Show;
   GeloestPanel.Hide; FertigPanel.Show;
end;

procedure THauptfenster.MenuSpielEndeClick(Sender: TObject);
begin Block:=true; Close end;

procedure THauptfenster.MenuHilfeRegelClick(Sender: TObject);
begin HilfeFenster.Show(0) end;

procedure THauptfenster.MenuHilfeBedienungClick(Sender: TObject);
begin HilfeFenster.Show(1) end;

procedure THauptfenster.MenuHilfeTricksClick(Sender: TObject);
begin HilfeFenster.Show(2) end;

procedure THauptfenster.MenuHilfeEinstellenClick(Sender: TObject);
begin Hilfefenster.Show(3) end;

procedure THauptfenster.MenuHilfeMenuClick(Sender: TObject);
begin Hilfefenster.Show(4) end;

procedure THauptfenster.MenuHilfeInfoClick(Sender: TObject);
begin Hilfefenster.Show(5) end;

end.
