unit Hilfe;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls;

type
  THilfeFenster = class(TForm)
    TabControl: TTabControl;
    Inhalt: TStaticText;
    procedure TabControlChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure Show(x:integer);
  end;

var
  HilfeFenster: THilfeFenster;

implementation

{$R *.DFM}
var HilfeTxt:array[0..5] of string=(

'Rechts sind alle Steine eines vollstndigen Domino-Spiels ausgelegt.'#013+
'Links ist ein Spielfeld, auf das alle diese Steine draufgelegt werden sollen.'#013+
'Wie man einen Stein hinlegt, siehe in der Hilfe "Bedienung".'#013#013+
'Jeder Stein darf aber nur - waagrecht oder senkrecht - dorthin gelegt werden, '+
'wo die Punktzahl in seinen beiden Feldern mit den Zahlen auf dem '+
'Spielfeld bereinstimmt. Bei jedem Start sind diese Zahlen normalerweise '+
'anders angeordnet.'#013#013+
'Am Anfang ist das sicher leicht, aber wenn man nicht aufpasst, hat man bald '+
'ein einzelnes Loch, in das kein Stein mehr passt, oder ein Doppelfeld, fr das '+
'der Stein schon woanders liegt.'#013#013+
'Wenn man nicht mehr so richtig weiter wei, gibt es Hilfemglichkeiten:'#013+
'Zurcklegen von Steinen, zeigen lassen, wo noch berall Steine mit '+
'bestimmten Augenzahlen hinpassen, zu einer bestimmten frheren Stellung '+
'zurckkehren, usw. Siehe dazu die Hilfe "Hilfestellungen".'#013#013+
'Wenn du ein Spiel ganz fertig hast, also alle Steine auf das Zahlenfeld '+
'gelegt hast, wird angezeigt, wie oft du von Hilfestellungen Gebrauch gemacht '+
'hast. Je weniger, umso besser natrlich deine Leistung!'#013#013+
'Oft gibt es mehrere richtige Lsungen, um das Feld mit allen Steinen zu '+
'belegen. Mindestens eine Lsung gibt es aber immer !'#013#013+
'Wenn dir eine vorgegebene Zahlenverteilung besonders gut gefllt, du sie '+
'spter nochmal versuchen mchtest, kannst du solche Aufgaben speichern '+
'und spter laden. Du kannst auch mit mehr oder mit weniger Dominosteinen '+
'spielen. Siehe dazu die Hilfe "Starten, Laden, Speichern."',

'Gehe mit dem Mauszeiger - keine Maustaste gedrckt - ber das Zahlenfeld. '+
'Du bewegst damit einen weien Rahmen in der Gre eines Dominosteins.'#013#013+
'Drcke die rechte Maustaste: der Rahmen ndert seine Richtung waagrecht '+
'oder senkrecht.'#013#013+
'Drcke die linke Maustaste: der zu den eingerahmten Zahlen passende '+
'Dominostein wird aus dem Vorrat geholt und auf das Zahlenfeld gelegt.'#013#013+
'Wenn der Stein nicht mehr im Vorrat ist, passiert dabei nichts, denn der Stein '+
'liegt schon woanders auf dem Zahlenfeld. Wenn du diesen Stein von dort '+
'lieber auf dem neuen Platz haben willst: drcke die linke Maustaste zweimal '+
'(Doppelklick): der Stein wird auf dem Zahlenfeld auf die neue Stelle gelegt.'#013#013+
'Wenn du einen Stein, der schon auf dem Zahlenfeld liegst, mit der rechten '+
'Maustaste anklickst, wird der Stein in den Vorrat zurckgelegt.'#013#013+
'Weitere Hilfestellungen beim Spiel findest du in der Hilfe "Hilfestellungen".',

'Whrend des Spiels kannst du von diesen Hilfestellungen Gebrauch machen. '+
'Dies wird aber mitgezhlt und am Schluss angezeigt. Eine Aufgabe mit '+
'weniger Hilfestellungen zu lsen, ist natrlich die bessere Leistung!'#013#013+
'- Stein zurcklegen und Stein umlegen: ist in der Hilfe "Bedienung" erklrt.'#013#013+
'- wo passt ein bestimmter Stein (noch) hin? Klicke mit der linken Maustaste auf einen '+
'Stein: an allen Stellen im Zahlenfeld, wo der Stein hinpasst, werden '+
'die Zahlen gelb.'#013#013+
'- wo ist eine bestimmte Zahl? Whle im Men "Spiel" den Punkt "Felder zeigen '+
'mit" und klicke auf die gewnschte Zahl: alle diese Zahlen werden im '+
'Zahlenfeld gelb.'#013+
'Du kannst stattdessen auch die gewnschte Zahl auf der Tastatur zusammen '+
'mit der Taste "Strg" drcken.'#013+
'(Wenn dich die gelben Zahlen spter stren, klicke irgenwo ins grne Fenster.)'#013#013+
'- Zwischenstand merken: Wenn du einige Steine gelegt hast, und willst jetzt '+
'erst einmal einige weiter nur probieren, und vielleicht wenns nicht geht, '+
'wieder an dieser Stelle weitermachen: Whle im Menu "Spiel" den Punkt '+
'"Ablegen"; dann mache deine Probezge. Willst du an die abgelegte Stelle '+
'zurck, whle im Men "Spiel" den Punkt "Holen".'#013+
'Statt Men kannst du auch die Tastenkombination "Strg" und "A" frs Ablegen '+
'oder "Strg" und "H" frs Holen drcken.'#013#013+
'- Lsung zeigen: Wenn du gar nicht zurecht kommst, aber auch, wenn du fertig '+
'bist, kannst du im Men "Spiel" den Punkt "Lsung zeigen" whlen: rechts, wo '+
'der Vorrat war, wird die Lsung angezeigt. Da es oft mehrere gibt, kann sie '+
'auch anders sein als die von dir gefundene.'#013+
'(Nach dem Zeigen der Lsung kannst du an dieser Aufgabe nicht weiterspielen; '+
'du musst eine neue Aufgabe whlen: siehe Hilfe "Starten, Laden, Speichern".)',

'Beim Start des Spiels wird immer ein neues Zahlenfeld fr ein 6-er Domino '+
'vorgegeben.'#013#013+
'Willst du mit mehr oder weniger vielen Steinen spielen, whle im Men "Spiel" '+
'den Punkt "Neues Spiel mit" und klicke auf die gewnschte Domino-Gre '+
'(1 bis 9). Das ist dann die hchste vorkommende Augenzahl.'#013+
'Ein 1-er Domino (sehr einfach) hat 3 Steine, ein 9-er Domino (das grte hier) '+
'hat 55 Steine.'#013#013+
'Willst du dasselbe Zahlenfeld nochmal spielen, whle im Menu "Spiel" den '+
'Punkt "Aufgabe Wiederholen"; willst du ein anderes Zahlenfeld, aber in derselben '+
'Gre wie bisher, spielen, whle den Punkt "Neue Aufgabe".'#013#013+
'Gefllt dir eine Aufgabe besonders, sodass du sie spter mal wieder spielen '+
'mchtest, kannst du sie in einer Datei speichern und spter wieder laden: '+
'Whle im Men "Spiel" den Punkt "Speichern in Datei" und spter dann '+
'"Laden aus Datei". Die Datei gibst du dann wie in Windows blich in einem '+
'Datei-Auswahlfenster an.'#013+
'Zu jeder Domino-Gre gibt es hier schon ein gespeichertes Spiel, die Dateien '+
'heien "EINS.DOM" bis "NEUN.DOM". Diese 9 gespeicherten Spiele haben als '+
'Besonderheit nur eine einzige, also eindeutige Lsung,.',

'Das Men "Spiel":'#013#013+
'Neue Aufgabe: Ein neues unbelegtes Zahlenfeld wird vorgegeben; die Domino-Gre '+
'bleibt wie bisher.'#013#013+
'Neues Spiel mit...: Aus einem Untermen wird eine Zahl von 1 bis 9 gewhlt; '+
'dann beginnt ein neues Spiel in der gewhlten Domino-Gre (entspricht der '+
'hchsten Augenzahl).'#013#013+
'Aufgabe wiederholen: Es werden alle Dominosteine vom Zahlenfeld in den Vorrat '+
'zurckgelegt.'#013#013+
'Laden aus Datei: Ein vorher gespeichertes Spiel kann in einem Dateiauswahlfenster '+
'gewhlt und dann gespielt werden. Es beginnt immer mit einem unbelegten Zahlenfeld, '+
'auch wenn es mitten im Spiel gespeichert wurde.'#013#013+
'Speichern in Datei: Das gerade vorhandene Spiel - Zahlenfeld und Domino-Gre - '+
'wird in einer Datei gespeichert. Die Datei kann man in einem Dateiauswahlfenster '+
'bestimmen. Die Standard-Endung ist .DOM'#013#013+
'Ablegen: Der gerade erreichte Zwischenstand bei einem Spiel wird "gemerkt".'#013#013+
'Holen: Der mit dem Menpunkt "Ablegen" gemerkte Spielstand wird wieder '+
'hergestellt.'#013#013+
'Felder zeigen mit ...: Ein Untermen erscheint, aus dem man eine Zahl whlen '+
'kann. Im Zahlenfeld erscheint diese Zahl berall, wo sie vorkommt, gelb.'#013#013+
'Lsung zeigen: An Stelle des Vorrats erscheint das gelste Spielfeld; das Spiel '+
'ist fertig.'#013#013+
'Ende: Das Programm wird beendet.',

'Version: Januar 2002'#013+
'Autor: Wolfgang Pavel'#13+
'EMail: pavel@mail.uni-wuerzburg.de'#013#013+
'Freeware - Alle Rechte vorbehalten.');

procedure THilfeFenster.Show(x:integer);
begin
   TabControl.SetBounds(0,0,ClientWidth,ClientHeight);
   TabControl.TabIndex:=x;
   Inhalt.SetBounds(8,28,ClientWidth-16,ClientHeight-36);
   Inhalt.Caption:=HilfeTxt[x];
   inherited Show;
end;

procedure THilfeFenster.TabControlChange(Sender: TObject);
begin Inhalt.Caption:=HilfeTxt[Tabcontrol.TabIndex] end;

end.
