unit hilfe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  StdCtrls;

type

  { THilfefenster }

  THilfefenster = class(TForm)
    Inhalt: TLabel;
    Tabs: TTabControl;
    procedure FormResize(Sender: TObject);
    procedure TabsChange(Sender: TObject);
  private

  public
    procedure Zeige(x:integer);
    procedure SetzeInhalt(x:integer);
  end;

var
  Hilfefenster: THilfefenster;

implementation

{$R *.lfm}

var HilfeTxt:array[0..5] of string=(
'Rechts sind alle Steine eines vollständigen Domino-Spiels ausgelegt.'+lineending+
'Links ist ein Spielfeld, auf das alle diese Steine draufgelegt werden sollen.'+lineending+
'Wie man einen Stein hinlegt, siehe in der Hilfe "Bedienung".'+lineending+lineending+
'Jeder Stein darf aber nur - waagrecht oder senkrecht - dorthin gelegt werden, '+
'wo die Punktzahl in seinen beiden Feldern mit den Zahlen auf dem '+
'Spielfeld übereinstimmt. Bei jedem Start sind diese Zahlen normalerweise '+
'anders angeordnet.'+lineending+lineending+
'Am Anfang ist das sicher leicht, aber wenn man nicht aufpasst, hat man bald '+
'ein einzelnes Loch, in das kein Stein mehr passt, oder ein Doppelfeld, für das '+
'der Stein schon woanders liegt.'+lineending+lineending+
'Wenn man nicht mehr so richtig weiter weiß, gibt es Hilfemöglichkeiten:'+lineending+
'Zurücklegen von Steinen, zeigen lassen, wo noch überall Steine mit '+
'bestimmten Augenzahlen hinpassen, zu einer bestimmten früheren Stellung '+
'zurückkehren, usw. Siehe dazu die Hilfe "Hilfestellungen".'+lineending+lineending+
'Wenn du ein Spiel ganz fertig hast, also alle Steine auf das Zahlenfeld '+
'gelegt hast, wird angezeigt, wie oft du von Hilfestellungen Gebrauch gemacht '+
'hast. Je weniger, umso besser natürlich deine Leistung!'+lineending+lineending+
'Oft gibt es mehrere richtige Lösungen, um das Feld mit allen Steinen zu '+
'belegen. Mindestens eine Lösung gibt es aber immer !'+lineending+lineending+
'Wenn dir eine vorgegebene Zahlenverteilung besonders gut gefällt, du sie '+
'später nochmal versuchen möchtest, kannst du solche Aufgaben speichern '+
'und später laden. Du kannst auch mit mehr oder mit weniger Dominosteinen '+
'spielen. Siehe dazu die Hilfe "Starten, Laden, Speichern."',

'Gehe mit dem Mauszeiger - keine Maustaste gedrückt - über das Zahlenfeld. '+
'Du bewegst damit einen weißen Rahmen in der Größe eines Dominosteins.'+lineending+lineending+
'Drücke die rechte Maustaste: der Rahmen ändert seine Richtung waagrecht '+
'oder senkrecht.'+lineending+lineending+
'Drücke die linke Maustaste: der zu den eingerahmten Zahlen passende '+
'Dominostein wird aus dem Vorrat geholt und auf das Zahlenfeld gelegt.'+lineending+lineending+
'Wenn der Stein nicht mehr im Vorrat ist, passiert dabei nichts, denn der Stein '+
'liegt schon woanders auf dem Zahlenfeld. Wenn du diesen Stein von dort '+
'lieber auf dem neuen Platz haben willst: drücke die linke Maustaste zweimal '+
'(Doppelklick): der Stein wird auf dem Zahlenfeld auf die neue Stelle gelegt.'+lineending+lineending+
'Wenn du einen Stein, der schon auf dem Zahlenfeld liegst, mit der rechten '+
'Maustaste anklickst, wird der Stein in den Vorrat zurückgelegt.'+lineending+lineending+
'Weitere Hilfestellungen beim Spiel findest du in der Hilfe "Hilfestellungen".',

'Während des Spiels kannst du von diesen Hilfestellungen Gebrauch machen. '+
'Dies wird aber mitgezählt und am Schluss angezeigt. Eine Aufgabe mit '+
'weniger Hilfestellungen zu lösen, ist natürlich die bessere Leistung!'+lineending+lineending+
'- Stein zurücklegen und Stein umlegen: ist in der Hilfe "Bedienung" erklärt.'+lineending+lineending+
'- wo passt ein bestimmter Stein (noch) hin? Klicke mit der linken Maustaste auf einen '+
'Stein: an allen Stellen im Zahlenfeld, wo der Stein hinpasst, werden '+
'die Zahlen gelb.'+lineending+lineending+
'- wo ist eine bestimmte Zahl? Wähle im Menü "Spiel" den Punkt "Felder zeigen '+
'mit" und klicke auf die gewünschte Zahl: alle diese Zahlen werden im '+
'Zahlenfeld gelb.'+lineending+
'Du kannst stattdessen auch die gewünschte Zahl auf der Tastatur zusammen '+
'mit der Taste "Strg" drücken.'+lineending+
'(Wenn dich die gelben Zahlen später stören, klicke irgenwo ins grüne Fenster.)'+lineending+lineending+
'- Zwischenstand merken: Wenn du einige Steine gelegt hast, und willst jetzt '+
'erst einmal einige weiter nur probieren, und vielleicht wenns nicht geht, '+
'wieder an dieser Stelle weitermachen: Wähle im Menu "Spiel" den Punkt '+
'"Ablegen"; dann mache deine Probezüge. Willst du an die abgelegte Stelle '+
'zurück, wähle im Menü "Spiel" den Punkt "Holen".'+lineending+
'Statt Menü kannst du auch die Tastenkombination "Strg" und "A" fürs Ablegen '+
'oder "Strg" und "H" fürs Holen drücken.'+lineending+lineending+
'- Lösung zeigen: Wenn du gar nicht zurecht kommst, aber auch, wenn du fertig '+
'bist, kannst du im Menü "Spiel" den Punkt "Lösung zeigen" wählen: rechts, wo '+
'der Vorrat war, wird die Lösung angezeigt. Da es oft mehrere gibt, kann sie '+
'auch anders sein als die von dir gefundene.'+lineending+
'(Nach dem Zeigen der Lösung kannst du an dieser Aufgabe nicht weiterspielen; '+
'du musst eine neue Aufgabe wählen: siehe Hilfe "Starten, Laden, Speichern".)',

'Beim Start des Spiels wird immer ein neues Zahlenfeld für ein 6-er Domino '+
'vorgegeben.'+lineending+lineending+
'Willst du mit mehr oder weniger vielen Steinen spielen, wähle im Menü "Spiel" '+
'den Punkt "Neues Spiel mit" und klicke auf die gewünschte Domino-Größe '+
'(1 bis 9). Das ist dann die höchste vorkommende Augenzahl.'+lineending+
'Ein 1-er Domino (sehr einfach) hat 3 Steine, ein 9-er Domino (das größte hier) '+
'hat 55 Steine.'+lineending+lineending+
'Willst du dasselbe Zahlenfeld nochmal spielen, wähle im Menu "Spiel" den '+
'Punkt "Aufgabe Wiederholen"; willst du ein anderes Zahlenfeld, aber in derselben '+
'Größe wie bisher, spielen, wähle den Punkt "Neue Aufgabe".'+lineending+lineending+
'Gefällt dir eine Aufgabe besonders, sodass du sie später mal wieder spielen '+
'möchtest, kannst du sie in einer Datei speichern und später wieder laden: '+
'Wähle im Menü "Spiel" den Punkt "Speichern in Datei" und später dann '+
'"Laden aus Datei". Die Datei gibst du dann wie üblich in einem '+
'Datei-Auswahlfenster an.'+lineending+
'Zu jeder Domino-Größe gibt es hier schon ein gespeichertes Spiel, die Dateien '+
'heißen "EINS.DOM" bis "NEUN.DOM". Diese 9 gespeicherten Spiele haben als '+
'Besonderheit nur eine einzige, also eindeutige Lösung,.',

'Neue Aufgabe: Ein neues unbelegtes Zahlenfeld wird vorgegeben; die Domino-Größe '+
'bleibt wie bisher.'+lineending+lineending+
'Neues Spiel mit...: Aus einem Untermenü wird eine Zahl von 1 bis 9 gewählt; '+
'dann beginnt ein neues Spiel in der gewählten Domino-Größe (entspricht der '+
'höchsten Augenzahl).'+lineending+lineending+
'Aufgabe wiederholen: Es werden alle Dominosteine vom Zahlenfeld in den Vorrat '+
'zurückgelegt.'+lineending+lineending+
'Laden aus Datei: Ein vorher gespeichertes Spiel kann in einem Dateiauswahlfenster '+
'gewählt und dann gespielt werden. Es beginnt immer mit einem unbelegten Zahlenfeld, '+
'auch wenn es mitten im Spiel gespeichert wurde.'+lineending+lineending+
'Speichern in Datei: Das gerade vorhandene Spiel - Zahlenfeld und Domino-Größe - '+
'wird in einer Datei gespeichert. Die Datei kann man in einem Dateiauswahlfenster '+
'bestimmen. Die Standard-Endung ist .DOM'+lineending+lineending+
'Ablegen: Der gerade erreichte Zwischenstand bei einem Spiel wird "gemerkt".'+lineending+lineending+
'Holen: Der mit dem Menüpunkt "Ablegen" gemerkte Spielstand – immer nur der letzte – wird wieder '+
'hergestellt.'+lineending+lineending+
'Felder zeigen mit ...: Ein Untermenü erscheint, aus dem man eine Zahl wählen '+
'kann. Im Zahlenfeld erscheint diese Zahl überall, wo sie vorkommt, gelb.'+lineending+lineending+
'Lösung zeigen: An Stelle des Vorrats erscheint das gelöste Spielfeld; das Spiel '+
'ist fertig.'+lineending+lineending+
'Ende: Das Programm wird beendet.',

'Version: Januar 2002 (Windows), Mai 2020 (Linux und Windows)'+lineending+
'Autor: Wolfgang Pavel'+lineending+
'EMail: post@wpavel.de'+lineending+lineending+
'Freeware - Alle Rechte vorbehalten.');

{ THilfefenster }

procedure THilfefenster.FormResize(Sender: TObject);
begin
  Tabs.SetBounds(0,0,ClientWidth,ClientHeight);
  Inhalt.SetBounds(8,28,ClientWidth-16,ClientHeight-36);
end;

procedure THilfefenster.Zeige(x:integer);
begin
  Tabs.TabIndex:=x;
  SetzeInhalt(x);
//  Inhalt.Caption:=lineending+HilfeTxt[x];
  Show;
end;

procedure THilfefenster.TabsChange(Sender: TObject);
begin
  if Tabs.TabIndex=6 then begin Close; exit; end;
  SetzeInhalt(Tabs.TabIndex);
//  Inhalt.Caption:=lineending+HilfeTxt[Tabs.TabIndex];
end;

procedure THilfefenster.SetzeInhalt(x:integer);
begin Inhalt.Caption:=lineending+Tabs.Tabs[x]+':'+lineending+lineending+HilfeTxt[x]; end;

end.

